<style lang="less">
@import '@/style/vars';
.ViewCalculis {
    height: 100vh;
    min-width: 960px;
    background: white;

    display: flex;
    flex-flow: column nowrap;
    align-items: stretch;
    justify-content: flex-start;
    &__head {flex: 0 0 auto}
    &__body {flex: 1 1 100%}

    &__head {
        flex: 0 0 auto;
        display: flex;
        flex-flow: row nowrap;
        align-items: center;
        justify-content: center;
        box-sizing: border-box;
        padding: 1rem;
        gap: 0.75rem;
        border-bottom: 1px solid @border-color;
        background: @color-ghost none no-repeat 0 0;
        backdrop-filter: saturate(150%) blur(12px);
        h1 {
            text-shadow: 0 1px 0 white;
            margin: 0 auto 0 0;
            font-weight: 600;
            font-size: 200%;

            display: inline-flex;
            flex-flow: column nowrap;
            align-items: flex-end;
            & > span {
                b {font-weight: 900}
            }
            & > sub {
                vertical-align: baseline;
                text-transform: uppercase;
                padding: 0 .125rem 0 0;
                font-size: 1rem;
                line-height: .75;
                font-weight: 400;
            }
        }
    }

    &__body {
        margin: 0 auto;
        width: 100%;
        box-sizing: border-box;
        max-width: 1200px;
        padding: 12px 24px 12px;
        // background: lightgoldenrodyellow;
        display: grid;
        grid-template-rows: 1fr;
        grid-template-columns: 240px 1fr 240px;
        @media (max-width: 1280px) {
            grid-template-columns: 200px 1fr 0px;
        }

        // &-sidebar {grid-column: 1 / 2}
        // &-content {grid-column: 2 / 3}
        &-body {
            box-shadow: inset 12px 12px 24px -16px rgba(50, 50, 50, .5);
            overflow: auto;
        }
        &-sidebar {
            min-width: 0px;
            border-right: 1px solid @border-color;
            padding: 0 12px 0 0;
            margin: 0 11px 0 0;
        }
        &-content {
            display: flex;
            flex-flow: column nowrap;
            justify-content: flex-start;
            align-items: center;
            box-sizing: border-box;
            min-height: 100%;
            max-width: 800px;
            margin: 0 auto;
        }

        h3 {
            width: 100%;
            font-size: 150%;
            font-weight: 300;
            margin: 0 0 .25rem;
        }
        .ReportTable + h3 {margin-top: 2rem}
        .ReportTable + .ReportTable {
            margin-top: 1rem;
        }

    }

    &__info {
        border-radius: .25rem;
        color: whitesmoke;
        background: royalblue;
        padding: .75rem;
        display: flex;
        flex-flow: row nowrap;
        a {color: lightcyan}

        & > .icon {
            color: lightgoldenrodyellow;
            text-shadow: 0 0 20px white;
            font-size: 48px;
            width: 1em;
            height: 1em;
            margin: 0 .25rem 0 0;
        }
        & > div {
            flex: 1 1 100%;
            padding: .5rem;
        }
        p {
            margin: 0;
            font-weight: 300;
            & + p {margin: .75rem 0 0}
        }
    }
}
</style>

<template>
<div class="ViewCalculis">
    <div class="ViewCalculis__head">
        <img src="@/img/logo.svg" width="98" height="48" alt="" />
        <h1>
            <span>Longevity<b>InTime</b></span>
            <sub>Metrics</sub>
        </h1>
        <GoogleButton />
        <YandexButton/>
    </div>

    <div class="ViewCalculis__body">
        <div class="ViewCalculis__body-sidebar">
            <CounterButtons @clickCounter='clickCounter'/>
        </div>
        <div class="ViewCalculis__body-content">

            <div class="ViewCalculis__info" v-if='!userinfo.google && !userinfo.yandex && false'>
                <i class="material-symbols-outlined icon" v-html='"&#xEBFE;"'/>
                <div>
                    <p>First you need to log in to Google and/or Yandex account.</p>
                    <p>
                        To use the service, your accounts must have access in Yandex.Metrics
                        and&nbsp;Google&nbsp;Analytics to the profiles listed here.
                    </p>
                    <p>You can see the profiles available to you here:
                        <a target="_balnk" href="https://metrika.yandex.ru/list?">Yandex</a>,
                        <a target="_balnk" href="https://ga-dev-tools.web.app/account-explorer/">Google</a>.
                        If you do not have access, contact the site manager for permission.
                    </p>
                </div>
            </div>

            <template v-else v-for='(rep, k) in reportsList' :key='k'>
                <h3>{{rep.counter.label}}</h3>
                <ReportTable v-if='rep.yandexReport'
                    :yandexReport='rep.yandexReport'/>

                <ReportTable v-if='rep.googleReport'
                    :googleReport='rep.googleReport'/>
            </template>
            <spinner v-if='pending'/>
        </div>
    </div>
</div>
</template>

<script lang="ts">
import {Vue, Options} from 'vue-class-component';
import {WebSiteProfile} from '@/types/metrics';
import GoogleButton from '@/components/GoogleButton.vue';
import YandexButton from '@/components/YandexButton.vue';
import CounterButtons from './CounterButtons.vue';
import ReportTable from './ReportTable.vue';

interface ReportData {
    counter:WebSiteProfile;
    yandexReport:any;
    googleReport:any;
}

@Options<ViewCalculis>({
    components: {
        YandexButton,
        GoogleButton,
        CounterButtons,
        ReportTable,
    },
    beforeMount() {
        // Promise.all([
        //     this.$store.dispatch('yandex/initialize'),
        //     this.$store.dispatch('google/initialize'),
        // ]).then(r => console.log('R', r[0], r[1]));

        this.reportsList = this.reportsCache;
        console.log('RL', this.reportsList);
    },
}) export default class ViewCalculis extends Vue {

    pending:boolean = false;
    async clickCounter(counter:WebSiteProfile|null) {
        this.pending = true;

        const {yandexReport, googleReport, errors} = await this.$store.dispatch('fetchPageviews', counter);
        console.log('PV', errors, yandexReport);

        if (errors?.length) alert(errors.join('\n'));
        else if (counter && (yandexReport || googleReport)) {

            const reports:ReportData[] = Array.from(this.reportsCache);

            console.log('RL!', [...reports]);
            const old = reports.findIndex(r => r.counter.key === counter.key);
            if (old !== -1) reports.splice(old, 1);
            reports.push({counter, yandexReport, googleReport});
            console.log('RL>', reports);

            this.reportsList = this.reportsCache = reports;
        }

        this.pending = false;
    }

    reportsList:ReportData[] = [];
    set reportsCache(reportsList:ReportData[]) {
        if (!reportsList) localStorage.removeItem('reportsList');
        else localStorage.setItem('reportsList', JSON.stringify(reportsList));
    }

    get reportsCache():ReportData[] {
        const reportsList = localStorage.getItem('reportsList');
        return reportsList ? JSON.parse(reportsList) : [];
    }

    get userinfo() {
        const google = this.$store.state.google?.userinfo || null;
        const yandex = this.$store.state.yandex?.userinfo || null;
        return {google, yandex};
    }
}
</script>